diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index a3ea0fdd1..7410b9e8e 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -549,7 +549,7 @@ public class PlayerServer extends Player implements ContainerListener {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_DISPENSER, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
         containerMenu.onCraftGuiClosed(this);
-        containerMenu = new MenuTrap(inventory, tileEntity);
+        containerMenu = new MenuDispenser(inventory, tileEntity);
         containerMenu.containerId = currentWindowId;
         containerMenu.addSlotListener(this);
     }
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 8a6a5ab67..1c6416ea0 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -109,7 +109,7 @@ public class PlayerList
 
     public void setPlayerManager(Int2ObjectMap<WorldServer> worldServerMap)
     {
-        playerIo = worldServerMap.get(0).getSaveHandler().getPlayerFileData();
+        playerIo = worldServerMap.get(0).getLevelStorage().getPlayerFileData();
     }
 
     public void syncPlayerDimension(PlayerServer player)
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index 71d88812f..6eb917c79 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -183,7 +183,18 @@ public class PacketHandlerLogin extends PacketHandler
             PacketHandlerServer packetHandler = new PacketHandlerServer(mcServer, netManager, player);
             try
             {
-                packetHandler.sendPacket(new PacketLogin("", new UUID(0, 0), player.id, worldserver.getRandomSeed(), (byte) worldserver.dimension.id, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver.dimensionData.getWorldType()), NetworkManager.PACKET_DELAY, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
+                packetHandler.sendPacket(
+                    new PacketLogin(
+                    "",
+                        new UUID(0, 0),
+                        player.id,
+                        worldserver.getRandomSeed(),
+                        (byte) worldserver.dimension.id,
+                        (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver.getDimensionData().getWorldType()),
+                        NetworkManager.PACKET_DELAY,
+                        RSA.getPublicKey(RSA.RSAKeyChain.getPublic())
+                    )
+                );
 
                 Key aesKey = AES.generateKey();
                 packetHandler.sendPacket(new PacketAESSendKey(RSA.encrypt(AES.getKey(aesKey), RSA.getPublicKey(loginPacket.publicKey))));
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 07cb884d0..7eb8556cb 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -42,18 +42,36 @@ public class WorldServer extends World
     private long lastWeatherSend = System.currentTimeMillis();
 
 
-    public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed)
-    {
-        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType, null);
+    public WorldServer(
+        MinecraftServer minecraftServer,
+        LevelStorage isavehandler,
+        String name,
+        int dimensionId,
+        long seed
+    ) {
+        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), null);
+
+        entityIntHashMap = new Int2ObjectOpenHashMap<>();
+        mcServer = minecraftServer;
+        getLevelData().setLastPlayerUUID(null);
+    }
+
+    public WorldServer(
+        MinecraftServer minecraftServer,
+        WorldServer parent,
+        int dimensionId
+    ) {
+        super(parent, Dimension.getDimensionList().get(dimensionId));
+
         entityIntHashMap = new Int2ObjectOpenHashMap<>();
-        mcServer = minecraftserver;
+        mcServer = minecraftServer;
         getLevelData().setLastPlayerUUID(null);
     }
 
     @Override
     protected IChunkProvider createChunkProvider()
     {
-        IChunkLoader ichunkloader = saveHandler.getChunkLoader(dimension);
+        IChunkLoader ichunkloader = this.getLevelStorage().getChunkLoader(dimension);
         this.chunkProviderServer = (ChunkProviderServer) Global.accessor.createChunkProvider(this, ichunkloader);
         return chunkProviderServer;
     }
@@ -76,8 +94,8 @@ public class WorldServer extends World
     @Override
     public boolean canMineBlock(final @NotNull Player player, final @NotNull TilePosc tilePos) {
         if (this.mcServer.spawnProtectionRange <= 0 || this.mcServer.playerList.isOp(player.uuid)) return super.canMineBlock(player, tilePos);
-        final int dx = (int)MathHelper.abs(tilePos.x() - this.levelData.getSpawnX());
-        final int dz = (int)MathHelper.abs(tilePos.z() - this.levelData.getSpawnZ());
+        final int dx = (int)MathHelper.abs(tilePos.x() - this.getLevelData().getSpawnX());
+        final int dz = (int)MathHelper.abs(tilePos.z() - this.getLevelData().getSpawnZ());
         return Math.max(dx, dz) > this.mcServer.spawnProtectionRange;
     }
 
@@ -122,8 +140,8 @@ public class WorldServer extends World
                     }
                 }
 
-                long timePlusOneDay = levelData.getWorldTime() + Global.DAY_LENGTH_TICKS;
-                levelData.setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + worldType.getSunriseTick(this) + Global.DAY_LENGTH_TICKS / 24);
+                long timePlusOneDay = getLevelData().getWorldTime() + Global.DAY_LENGTH_TICKS;
+                getLevelData().setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + worldType.getSunriseTick(this) + Global.DAY_LENGTH_TICKS / 24);
                 wakeUpAllPlayers();
             }
         }
@@ -227,7 +245,7 @@ public class WorldServer extends World
 
     public void checkLock()
     {
-        saveHandler.checkSessionLock();
+        this.getLevelStorage().checkSessionLock();
     }
     @Override
     public void tick() {
diff --git a/util/datagen/build.gradle.kts b/util/datagen/build.gradle.kts
index 9f0a275e2..49736ad3d 100644
--- a/util/datagen/build.gradle.kts
+++ b/util/datagen/build.gradle.kts
@@ -31,8 +31,8 @@ val runDatagen by tasks.registering(JavaExec::class) {
     args = listOf("--output", recipesDir.toString())
 }
 
-val datagenJar by tasks.registering(Jar::class) {
-    group = "bta.generator"
+tasks.named("jar", Jar::class) {
+    duplicatesStrategy = DuplicatesStrategy.INCLUDE;
     from(sourceSets["generated"].resources)
 }
 //endregion
@@ -46,5 +46,5 @@ sourceSets {
 }
 
 artifacts {
-    add("output", datagenJar)
+    add("output", tasks.getAt("jar"))
 }
\ No newline at end of file
diff --git a/util/seed-viewer/build.gradle.kts b/util/seed-viewer/build.gradle.kts
index 0a64b8598..0d1f2e98f 100644
--- a/util/seed-viewer/build.gradle.kts
+++ b/util/seed-viewer/build.gradle.kts
@@ -54,7 +54,6 @@ val versionGenerator by tasks.registering {
                     
                     final class Version {
                         public static final String VERSION = "$version";
-                        public static final long BUILD_TIME = ${Date().time}L;
                     }
                 """.trimIndent()
         )
